package game.control;

import game.Game;
import game.GameUpdate;
import game.objects.Creature;

import java.awt.event.KeyEvent;
import java.util.ArrayList;

public abstract class KeyboardControl extends Control {

    protected ArrayList<KeyEvent> keyEvents;
    protected KeyboardControlConfiguration configuration;

    public KeyboardControl(Game game, Creature controlledCreature) {
        this(game, controlledCreature,
                KeyboardControlConfiguration.STANDARD_CONFIGURATION);
    }

    public KeyboardControl(Game game, Creature controlledCreature,
            KeyboardControlConfiguration configuration) {
        super(game, controlledCreature);

        this.keyEvents = new ArrayList<KeyEvent>();
        this.configuration = configuration;
    }

    @Override
    public void update(GameUpdate update) {
        keyEvents.addAll(update.getKeyEvents());
        super.update(update);
    }
}
