package game.res;

import game.Game;
import game.GameConfig;

import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.Hashtable;

import javax.imageio.ImageIO;

public class ContentManager {

    protected Game game;
    private Hashtable<String, BufferedImage> imageMap;
    private Hashtable<String, String> textMap;

    public ContentManager(Game game) {
        
        this.game = game;
        imageMap = new Hashtable<String, BufferedImage>();
        textMap = new Hashtable<String, String>();
    }

    public void loadImage(String key, String path) {

        try {
            imageMap.put(key, ImageIO.read(new File(game.getConfig().getImageDir(), path)));
        } catch (IOException e) {}
    }

    public void loadText(String key, String path) {

        try {
            BufferedReader reader = new BufferedReader(new FileReader(path));
            StringBuilder builder = new StringBuilder();
            String line;
            
            while ((line = reader.readLine()) != null) {
                builder.append(line).append("\n");
            }
            
            textMap.put(key, builder.toString());
            reader.close();
            
        } catch (IOException e) {}
    }
    
    public GameConfig getConfig() {
        return game.getConfig();
    }

    public BufferedImage getImage(String key) {
        return imageMap.get(key);
    }

    public String getText(String key) {
        return textMap.get(key);
    }
}
