package geometry;

public class Vector2D {

	protected double x;
	protected double y;

	public Vector2D(double x, double y) {

		this.x = x;
		this.y = y;
	}

	public Vector2D add(Vector2D v) {
		return new Vector2D(this.x + v.x, this.y + v.y);
	}

	public double distance(Vector2D that) {
		return Math.sqrt(Math.pow(that.x - this.x, 2)
				+ Math.pow(that.y - this.y, 2));
	}

	public double getX() {
		return this.x;
	}

	public double getY() {
		return this.y;
	}

	public double length() {
		return Math.sqrt(x * x + y * y);
	}

	public Vector2D multiply(double d) {
		return new Vector2D(d * x, d * y);
	}

	public Vector2D normalized() {
		double length = length();

		if (length != 0) {
			return new Vector2D(x / length, y / length);
		}

		return new Vector2D(0, 0);
	}

	public void setX(double x) {

		this.x = x;
	}

	public void setY(double y) {
		this.y = y;
	}

	public Vector2D subtract(Vector2D v) {
		return new Vector2D(x - v.x, y - v.y);
	}

	@Override
	public String toString() {
		return "(" + getX() + ", " + getY() + ")";
	}
}
